<?php

namespace Drupal\rabbit_hole_href;

use Drupal\rabbit_hole\Plugin\RabbitHoleBehaviorPluginManager;
use Drupal\Core\Entity\EntityInterface;


/**
 * Handles the delegation for the canonical link of the given entity.
 */
class CanonicalUrlRhDelegateResolver implements CanonicalLinkDelegateResolverInterface {

  /**
   * Drupal\rabbit_hole\Plugin\RabbitHoleBehaviorPluginManager definition.
   *
   * @var Drupal\rabbit_hole\Plugin\RabbitHoleBehaviorPluginManager
   */
  protected $rhBehaviorPluginManager;

  /**
   * Constructor.
   */
  public function __construct(RabbitHoleBehaviorPluginManager $plugin_manager_rabbit_hole_behavior_plugin) {
    $this->rhBehaviorPluginManager = $plugin_manager_rabbit_hole_behavior_plugin;
  }

  /**
   * @inheritDoc
   */
  public function getCanonicalUrlDelegate(EntityInterface $entity){
    return $this->rhBehaviorPluginManager->createInstance('page_redirect_href')->getActionTarget($entity);
  }
}
