<?php

namespace Drupal\rabbit_hole_href\Plugin;

use Drupal\rabbit_hole\Plugin\RabbitHoleBehaviorPluginInterface;
use Drupal\Core\Entity\EntityInterface;

/**
 * Interface RabbitHoleActionTargetBehaviorPluginInterface.
 *
 * Defines an interface for Rabbit hole behavior plugin plugins which returns an
 * action target to rewrite links pointing to the handled entity.
 *
 * @package rabbit_hole_href
 */
interface RabbitHoleActionTargetBehaviorPluginInterface extends RabbitHoleBehaviorPluginInterface {

  /**
   * Returns the action target URL like determined as redirect target in
   * Drupal\rabbit_hole\Plugin\RabbitHoleBehaviorPlugin\PageRedirect::performAction().
   *
   * @param EntityInterface $entity
   * @return Drupal\Core\Url
   */
  public function getActionTarget(EntityInterface $entity);

}
